''***************************************
''*  EMU Text 32x15 v1.0                *
''*  Text ouput functions for propeller *
''*  emulator                           *
''*  Author: Chris Micro                *
''*  derived from VGA Text              *
''***************************************
''***************************************
''*  VGA Text 32x15 v1.0                *
''*  Author: Chip Gracey                *
''*  Copyright (c) 2006 Parallax, Inc.  *
''*  See end of file for terms of use.  *
''***************************************

CON
  HUBMEMPUTCHAR = $F000 'emulator hub memory address to output chracters
  cols = 32
  rows = 15

  screensize = cols * rows
  lastrow = screensize - cols

VAR
  long  col, row, color, flag

PUB start(basepin) : okay
'' Start terminal - starts a cog
  'out(0) 'clear screen
PUB stop

pub putchar(c)
  byte[HUBMEMPUTCHAR][0]:=c
  'byte[$F000][0]:=$d
PUB outString(stringptr)
'' Print a zero-terminated string
  repeat strsize(stringptr)
    putchar(byte[stringptr++])

PUB setcolors(c)
  ' uses escape sequences for the linux console

  case c
    0: outString(string(27,"[37m",27,"[44m",0))
    1: outString(string(27,"[93m",27,"[43m",0))
    2: outString(string(27,"[95m",27,"[40m",0))
    3: outString(string(27,"[30m",27,"[47m",0))
    4: outString(string(27,"[96m",27,"[46m",0))
    5: outString(string(27,"[32m",27,"[47m",0))
    6: outString(string(27,"[31m",27,"[101m",0))
    7: outString(string(27,"[96m",27,"[44m",0))
    other: outString(string(27,"[0m",0)) 'all atributes off, not in vga_text.spin


PUB out(c) | i, k

'' Output a character
''
''     $00 = clear screen
''     $01 = home
''     $08 = backspace
''     $09 = tab (8 spaces per)
''     $0A = set X position (X follows)
''     $0B = set Y position (Y follows)
''     $0C = set color (color follows)
''     $0D = return
''  others = printable characters

  case flag
    $00: case c
           $00: outString(string(27,"[0m",27,"[2J",0))
                col := row := 0
           $01: col := row := 0
           $08: if col
                  col--
           $09: repeat
                  putchar(" ")
                while col & 7
           $0A..$0C: flag := c
                     return
           $0D: newline
           other:   putchar(c)

    $0A: 'outString(string(27,"[",0))
         putchar(27)
         putchar(91)
         putchar(c/10+"0")
         putchar(c//10+"0")
         putchar(71)
    $0B: row := c // rows
    $0C: setcolors(c)
  flag := 0
{{   case 0x0A: // move to column
   {
     printf ("\033[%dG",zeichen);

     escape=0;
   }break;
   case 0x0B: // move to row
   {
printf ("\033[999A"); // mov cursor 999 lines up ( hopefully the first row
printf ("\033[%dB",zeichen); // from there mov cursor down to desired postion
}}
PUB str(stringptr)

'' Print a zero-terminated string

  repeat strsize(stringptr)
    out(byte[stringptr++])


PUB dec(value) | i

'' Print a decimal number

  if value < 0
    -value
    out("-")

  i := 1_000_000_000

  repeat 10
    if value => i
      out(value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      out("0")
    i /= 10


PUB hex(value, digits)

'' Print a hexadecimal number

  value <<= (8 - digits) << 2
  repeat digits
    out(lookupz((value <-= 4) & $F : "0".."9", "A".."F"))


PUB bin(value, digits)

'' Print a binary number

  value <<= 32 - digits
  repeat digits
    out((value <-= 1) & 1 + "0")
PUB newline
  outString(string(10,0))

